import { useConfig } from '@kevisual/use-config';
import { app } from './index.ts';
import { useContext } from '@kevisual/use-config/context';
import { sequelize, User, OrgInit, UserInit } from '@kevisual/code-center-module';
const config = useConfig();

const context = useContext();

// http://localhost:3006/api/router?path=user&key=list
setTimeout(() => {
  const org = OrgInit();
  console.log('org', org);
  const user = UserInit();
  console.log('user', user);
}, 2000);
app
  .route({
    path: 'user',
    key: 'list',
    isDebug: true,
  })
  .define(async (ctx) => {
    const u = await User.findOne();
    ctx.body = u;
  })
  .addTo(app);

app.listen(config.port, () => {
  console.log(`server is running at http://localhost:${config.port}`);
});
